from rest_framework import viewsets
from rest_framework.decorators import action
from rest_framework.request import Request
from django.http import HttpResponse, JsonResponse

from ..Clients.CosmohomeClient import generate_xml_task, generate_stats
from django.conf import settings


class CosmohomeView(viewsets.ViewSet):
    @classmethod
    @action(methods=['get'], detail=False, url_path='generate/xml')
    def generate_xml(cls, request: Request, *args, **kwargs) -> HttpResponse:
        filepath = "artifacts/cosmohome_products.xml"
        final_xml = generate_xml_task(filepath)
        return HttpResponse('ok')

    @classmethod
    @action(methods=['get'], detail=False, url_path='stats')
    def generate_xml(cls, request: Request, *args, **kwargs) -> JsonResponse:
        filepath = "artifacts/cosmohome_products.xml"
        stats = generate_stats(filepath)
        return JsonResponse(stats)

    @classmethod
    @action(methods=['get'], detail=False, url_path='xml')
    def xml(cls, request: Request, *args, **kwargs) -> HttpResponse:
        filepath = settings.BASE_DIR / "artifacts/cosmohome_products.xml"
        try:
            with open(filepath, 'rb') as f:
                return HttpResponse(f.read(), content_type='text/xml')
        except OSError:
            print(f"No available {filepath} file. Please generate one first.")
            pass
        return HttpResponse('No available xml file. Please generate one first.', status=404)